#include "ES.hh"

int main (int argc, char** argv)
{
	using skeleton ES;
	char path[MAX_BUFFER];
	int len;
	int longitud;

	system("clear");

	get_path(argv[0],path);
	len = strlen(path) + 1;
	longitud = MAX_BUFFER - len;

	sprintf(path,"%s/Config.cfg",path);
	ifstream f(path);
	if(!f) show_message(2);

	f.getline(&(path[len]),longitud,'\n');
	ifstream f1(path);
	if(!f1)	show_message(2);

	f.getline(&(path[len]),longitud,'\n');
	ifstream f2(path);
	if(!f2) show_message(9);

	Problem pbm;
	f2 >> pbm;

	Operator_Pool pool(pbm);
	SetUpParams cfg(pool);
	f1 >> cfg;


	Solver_Wan solver(pbm,cfg,argc,argv);
	solver.run();

	if (solver.pid()==0)
	{
		solver.show_state();
		cout << "Solucion: " << solver.global_best_solution() << endl << " Fitness: " << solver.global_best_solution().fitness();

		f.getline(&(path[len]),longitud,'\n');
	  	ofstream fexit(path);
	  	if(!fexit) show_message(2);
	  	fexit << solver.userstatistics();

		cout << endl << endl << " :( ---------------------- THE END --------------- :) " << endl;
	}
	return(0);
}
