#ifndef INC_REQ_newGASA
#define INC_REQ_newGASA

#include "newGASA.hh"
#include "newGA.hh"
#include "newGASAaux.hh"

skeleton newGASA
{
	// Problem ---------------------------------------------------------------

	Problem::Problem ()
	{}

	ostream& operator<< (ostream& os, const Problem& pbm)
	{
		return os;
	}

	istream& operator>> (istream& is, Problem& pbm)
	{
		return is;
	}
	
	Problem& Problem::operator=  (const Problem& pbm)
	{
		return *this;
	}

	bool Problem::operator== (const Problem& pbm) const
	{
		return true;
	}

	bool Problem::operator!= (const Problem& pbm) const
	{
		return !(*this == pbm);
	}

	Direction Problem::direction() const
	{
		return maximize;
		//return minimize;
	}

	Problem::~Problem()
	{}

	// Solution --------------------------------------------------------------

	Solution::Solution (const Problem& pbm):_pbm(pbm)
	{}

	const Problem& Solution::pbm() const
	{
		return _pbm;
	}

	Solution::Solution(const Solution& sol):_pbm(sol.pbm())
	{
		*this=sol;
	}

	istream& operator>> (istream& is, Solution& sol)
	{
		return is;
	}

	ostream& operator<< (ostream& os, const Solution& sol)
	{
		return os;
	}

	NetStream& operator << (NetStream& ns, const Solution& sol)
	{
		return ns;
	}

	NetStream& operator >> (NetStream& ns, Solution& sol)
	{
		return ns;
	}

 	Solution& Solution::operator= (const Solution &sol)
	{
		return *this;
	}

	bool Solution::operator== (const Solution& sol) const
	{
		if (sol.pbm() != _pbm) return false;
		return true;
	}

	bool Solution::operator!= (const Solution& sol) const
	{
		return !(*this == sol);
	}

	void Solution::initialize()
	{}

	double Solution::fitness () const
	{
		double fitness = 0.0;
		return fitness;
	}

	char *Solution::to_String() const
	{
		return NULL;
	}

	void Solution::to_Solution(char *_routes_)
	{}

	unsigned int Solution::size() const
	{
		return 0;
	}

	Solution::~Solution()
	{}


// Intra_operator  --------------------------------------------------------------

	Intra_Operator::Intra_Operator(const unsigned int _number_op):_number_operator(_number_op),probability(NULL)
	{}

	unsigned int Intra_Operator::number_operator() const
	{
		return _number_operator;
	}

	Intra_Operator *Intra_Operator::create(const unsigned int _number_op)
	{
		switch (_number_op)
		{
			case 0: return new Crossover();break;
			case 1: return new Mutation();break;
			case 2: return new Improve(); break;
		}
	}

	ostream& operator<< (ostream& os, const Intra_Operator& intra)
	{
		switch (intra.number_operator())
		{
			case 0: os << (Crossover&)intra;break;
			case 1: os << (Mutation&)intra;break;
			case 2: os << (Improve&)intra;break;
		}
		return os;
	}

	Intra_Operator::~Intra_Operator()
	{}

//  Crossover_PMX1:Intra_operator -------------------------------------------------------------

	Crossover::Crossover():Intra_Operator(0)
	{
	//	probability = new float[1];
	}

	void Crossover::cross(Solution& sol1,Solution& sol2) const // dadas dos soluciones de la poblacion, las cruza
	{}

	void Crossover::execute(Rarray<Solution*>& sols) const
	{
		for (int i=0;i+1<sols.size();i=i+2)
		 	if (rand01()<=probability[0]) cross(*sols[i],*sols[i+1]);
	}

	ostream& operator<< (ostream& os, const Crossover&  cross)
	{
		 os << "Crossover.";
		 // << " Probability: " << cross.probability[0];		
		 return os;
	}

	void Crossover::RefreshState(const StateCenter& _sc) const
	{
//		 _sc.set_contents_state_variable("_crossover_probability",(char *)probability,1,sizeof(float));
	}

	void Crossover::UpdateFromState(const StateCenter& _sc)
	{
		 unsigned long nbytes,length;
//		 _sc.get_contents_state_variable("_crossover_probability",(char *)probability,nbytes,length);
	}

	void Crossover::setup(char line[MAX_BUFFER])
	{
		int op;
//		sscanf(line," %d %f ",&op,&probability[0]);
//		assert(probability[0]>=0);
	}

	Crossover::~Crossover()
	{
		delete [] probability;
	}

	//  Mutation: Sub_operator -------------------------------------------------------------

	Mutation::Mutation():Intra_Operator(1)
	{
	//	probability = new float[1];
	}

	void Mutation::mutate(Solution& sol) const
	{}

	void Mutation::execute(Rarray<Solution*>& sols) const
	{
		for (int i=0;i<sols.size();i++)
			if(rand01() <= probability[0])	mutate(*sols[i]);
	}

	ostream& operator<< (ostream& os, const Mutation&  mutation)
	{
		os << "Mutation.";
		// << " Probability: " << mutation.probability[0];
		return os;
	}

	void Mutation::setup(char line[MAX_BUFFER])
	{
//		int op;
//		sscanf(line," %d %f",&op,&probability[0]);
//		assert(probability[0]>=0);
	}

	void Mutation::RefreshState(const StateCenter& _sc) const
	{
//		_sc.set_contents_state_variable("_mutation_probability",(char *)probability,1,sizeof(probability));
	}

	void Mutation::UpdateFromState(const StateCenter& _sc)
	{
		unsigned long nbytes,length;
//		_sc.get_contents_state_variable("_mutation_probability",(char *)probability,nbytes,length);
	}

	Mutation::~Mutation()
	{
		delete [] probability;
	}

// Movement  -------------------------------------------------------

	Movement::Movement()
	{}

	Movement::~Movement()
	{}

	void Movement::Apply (Solution& sol) const
	{}

}

#endif
